hdu1255覆盖的面积

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 4135    Accepted Submission(s): 2041

Problem Description

给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积.

Input

输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数据的第一行是一个正整数N(1<=N<=1000),代表矩形的数量,然后是N行数据,每一行包含四个浮点数,代表平面上的一个矩形的左上角坐标和右下角坐标,矩形的上下边和X轴平行,左右边和Y轴平行.坐标的范围从0到100000.

注意:本题的输入数据较多,推荐使用scanf读入数据.

Output

对于每组测试数据,请计算出被这些矩形覆盖过至少两次的区域的面积.结果保留两位小数.

Sample Input

2
5
1 1 4 2
1 3 3 7
2 1.5 5 4.5
3.5 1.25 7.5 4
6 3 10 7
3
0 0 1 1
1 0 2 1
2 0 3 1

Sample Output

7.63
0.00

Author

Ignatius.L & weigang Lee

Recommend

Ignatius.L   |   We have carefully selected several similar problems for you:  1540 1828 1823 3016 2871

我对我的线段树很有自信,直接cin

#include<map>
#include<string>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<queue>
#include<vector>
#include<iostream>
#include<algorithm>
#include<bitset>
#include<climits>
#include<list>
#include<iomanip>
#include<stack>
#include<set>
using namespace std;
double hs[2010];
struct Tree
{
	int l,r,num;
	double val,len;
}tree[2000<<2];
void create(int l,int r,int k)
{
	tree[k].l=l;
	tree[k].r=r;
	tree[k].num=0;
	tree[k].val=tree[k].len=0;
	if(l+1==r)
		return;
	int m=l+r>>1;
	create(l,m,k<<1);
	create(m,r,k<<1|1);
}
void update(int l,int r,int k,int flag)
{
	if(tree[k].l==l&&tree[k].r==r)
	{
		tree[k].num+=flag;
		if(tree[k].num==0)
		{
			tree[k].val=l+1==r?0:tree[k<<1].val+tree[k<<1|1].val;
			tree[k].len=l+1==r?0:tree[k<<1].len+tree[k<<1|1].len;
		}
		else
		{
			tree[k].val=hs[r]-hs[l];
			if(tree[k].num==1)
				tree[k].len=l+1==r?0:tree[k<<1].val+tree[k<<1|1].val;
			else
				tree[k].len=hs[r]-hs[l];
		}
		return;
	}
	int m=tree[k].l+tree[k].r>>1;
	if(r<=m)
		update(l,r,k<<1,flag);
	else if(l>=m)
		update(l,r,k<<1|1,flag);
	else
	{
		update(l,m,k<<1,flag);
		update(m,r,k<<1|1,flag);
	}
	if(tree[k].num==0)
	{
		tree[k].val=tree[k<<1].val+tree[k<<1|1].val;
		tree[k].len=tree[k<<1].len+tree[k<<1|1].len;
	}
	else if(tree[k].num==1)
		tree[k].len=tree[k<<1].val+tree[k<<1|1].val;
}
struct Seg
{
	int flag;
	double l,r,y;
	bool operator <(Seg one)const
	{
		return y<one.y;
	}
}seg[2010];
int main()
{
	int T;
	cin>>T;
	while(T--)
	{
		int n;
		cin>>n;
		vector<double>box;
		for(int i=0;i<n;i++)
		{
			double x1,y1,x2,y2;
			cin>>x1>>y1>>x2>>y2;
			seg[i<<1].l=seg[i<<1|1].l=x1;
			seg[i<<1].r=seg[i<<1|1].r=x2;
			seg[i<<1].y=y1;
			seg[i<<1|1].y=y2;
			seg[i<<1].flag=1;
			seg[i<<1|1].flag=-1;
			box.push_back(x1);
			box.push_back(x2);
		}
		sort(box.begin(),box.end());
		box.erase(unique(box.begin(),box.end()),box.end());
		for(int i=0;i<box.size();i++)
			hs[i+1]=box[i];
		n*=2;
		sort(seg,seg+n);
		double ans=0;
		create(1,box.size(),1);
		for(int i=0;i<n;i++)
		{
			int l=1+lower_bound(box.begin(),box.end(),seg[i].l)-box.begin();
			int r=1+lower_bound(box.begin(),box.end(),seg[i].r)-box.begin();
			if(i!=n-1)
			{
				update(l,r,1,seg[i].flag);
				ans+=tree[1].len*(seg[i+1].y-seg[i].y);
			}
		}
		printf("%.2f\n",ans);
	}
}
时间: 2024-10-21 17:02:03

hdu1255覆盖的面积的相关文章

HDU1255 覆盖的面积 【扫描线】

覆盖的面积 Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3743    Accepted Submission(s): 1838 Problem Description 给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积. Input 输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数

HDU-1255 覆盖的面积 (扫描线)

题目大意:给若干个矩形,统计重叠次数不为0的面积. 题目分析:维护扫描线的长度时,只需要只统计覆盖次数大于1的区间即可.这是个区间更新,不过不能使用懒标记,但是数据规模不大,不用懒惰标记仍可以AC. 代码如下: # include<iostream> # include<cstdio> # include<map> # include<vector> # include<cstring> # include<algorithm> us

HDU-1255 覆盖的面积(线扫描)

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1255 中文题意就不用再说了. 这是赤裸裸的线扫描问题,唯一不同的就是求得面积是覆盖超过两次的面积的大小.其实就是求覆盖面积里面多一个变量来存储覆盖一次的长度(HDU 1542). 这里有一个小小的坑点,要注意if语句判断的顺序. 1 #include<cstdio> 2 #include<algorithm> 3 using namespace std; 4 5 const int max

hdu1255 覆盖的面积(线段树面积交)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1255 面积交与面积并相似相比回了面积并,面积交一定会有思路,当然就是cover标记大于等于两次时. 但是操作起来发现与面积并有些不同.面积交要从面积并的状态转过来.当cover值为1的时候交 的长度可以为(p为当前节点len1为并的区间长度,len2为交的区间长度) T[p].len2=T[p<<1].len1+T[(p<<1)|1].len1.这样也能满足cover为2. 当cove

hdu1255 覆盖的面积 线段树-扫描线

矩形面积并 线段树-扫描线裸题 1 #include<stdio.h> 2 #include<string.h> 3 #include<algorithm> 4 #include<math.h> 5 using namespace std; 6 const int maxm=2e3+5; 7 const double eps=1e-5; 8 9 struct seg{ 10 double x,y1,y2; 11 int c; 12 bool operator

HDU 1255 覆盖的面积 (求矩形面积的交)

覆盖的面积 Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Description 给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积. Input 输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数据的第一行是一个正整数N(1<=N<=1000),代表矩形的数量,然后是N行数据,每一行包含四个浮点数,代表平面上的一个

hdu 1255 覆盖的面积(扫描线)

http://acm.hdu.edu.cn/showproblem.php?pid=1255 一道挺简单的题,让我折腾了许久.主要卡在了更新节点后维护父亲节点上.后来思路明确了就很容易了. 节点信息: l,r:区间端点 cnt:区间被覆盖的次数,cnt = 0说明没有被完全覆盖. len1:区间被覆盖的长度 len2:区间至少被两条线段覆盖的长度. 只要找到父亲节点与子节点在len1,len2,cnt的关系就简单了. #include <stdio.h> #include <iostre

hdu 1255 覆盖的面积

http://acm.hdu.edu.cn/showproblem.php?pid=1255 1 #include <cstdio> 2 #include <cstring> 3 #include <algorithm> 4 #define maxn 100010 5 using namespace std; 6 7 int t,n; 8 double Y[maxn],X[maxn]; 9 struct point 10 { 11 double x; 12 double

HDU 1255 覆盖的面积 (扫描线 线段树 离散化)

题目链接 题意:中文题意. 分析:纯手敲,与上一道题目很相似,但是刚开始我以为只是把cnt>=0改成cnt>=2就行了,. 但是后来发现当当前加入的线段的范围之前 还有线段的时候就不行了,因为虽然现在都不等于 2,但是之前的那个线段加上现在的已经覆盖2次了. 1 #include <iostream> 2 #include <cstdio> 3 #include <vector> 4 #include <cstring> 5 #include &